<?php

define('EVC_API_URL','https://api.vk.com/method/');


register_activation_hook(__FILE__,'evc_activate');
function evc_activate (){
  $use_smilies = get_option('use_smilies');
  if ($use_smilies)
    update_option('use_smilies', false);   
}



// load all the subplugins
add_action('plugins_loaded','evc_plugin_loader');
function evc_plugin_loader() {
  include_once('evc-share.php');
  include_once('evc-stats.php');
	include_once('evc-comments.php');
}

// add the theme page
add_action('admin_menu', 'evc_add_page');
function evc_add_page() {
  global $evc_options_page;
  
  add_menu_page( 'Easy VKontakte Connect', 'Easy VK Connect', 'activate_plugins', 'evc', 'evc_vk_api_settings_page', '', '99.02' ); 
}


// add the admin settings and such
add_action('admin_init', 'evc_admin_init'); 
function evc_admin_init(){
  global $evc_options_page; 
  evc_activate();
  //$options = get_option('evc_options');
 
  // Isotope DEPRECATED because:
  // https://make.wordpress.org/plugins/2012/12/20/gpl-and-the-repository/ 
  //wp_enqueue_script('jquery.isotope', plugins_url('js/jquery.isotope.min.js' , __FILE__), array('jquery', 'jquery-masonry'));   
  
  wp_enqueue_script('evc', plugins_url('js/evc.js' , __FILE__), array('jquery', 'jquery-masonry'), '1.0', true);  
  wp_enqueue_script('bootstrap', plugins_url('js/bootstrap.min.js' , __FILE__), array('jquery'), '2.2.2', true);  
  wp_enqueue_script('tinysort', plugins_url('js/jquery.tinysort.js' , __FILE__), array('jquery'), true); 
  
}


class EVC_Walker_Checklist extends Walker {
  var $tree_type = 'category';
  var $db_fields = array ('parent' => 'parent', 'id' => 'term_id'); //TODO: decouple this
  
  function start_lvl(&$output, $depth = 0, $args = array()) {
    $indent = str_repeat("\t", $depth);
    $output .= "$indent<ul class='children'>\n";
  }

  function end_lvl(&$output, $depth = 0, $args = array()) {
    $indent = str_repeat("\t", $depth);
    $output .= "$indent</ul>\n";
  }

  function start_el(&$output, $object, $depth = 0, $args = array(), $current_object_id = 0 ) {
    extract($args);
    if ( empty($taxonomy) )
      $taxonomy = 'category';
    $_name = apply_filters('wpsapi_checklist_name', '');
    /*
    if ( $taxonomy == 'category' ) {
      $name = 'evc_options[post_category]';
      //$name = $_name . '[post_category]';
    }
    else {
      $name = 'evc_options[tax_input]['.$taxonomy.']';
      //$name = $_name . '[tax_input]['.$taxonomy.']';
    }
    */
    $name = $_name ;
    
    $class = in_array( $object->term_id, $popular_cats ) ? ' class="popular-category"' : '';
    $output .= "\n<li id='{$taxonomy}-{$object->term_id}'$class>" . '<label class="selectit"><input value="' . $object->term_id . '" type="checkbox" name="'.$name.'[]" id="in-'.$taxonomy.'-' . $object->term_id . '"' . checked( in_array( $object->term_id, $selected_cats ), true, false ) . disabled( empty( $args['disabled'] ), false, false ) . ' /> ' . esc_html( apply_filters('the_category', $object->name )) . '</label>';
  }

  function end_el(&$output, $object, $depth = 0, $args = array()) {
    $output .= "</li>\n";
  }
}



add_action('post_submitbox_misc_actions','evc_wall_post_check_box');
function evc_wall_post_check_box() {
  global $post;
  $options = get_option('evc_options');
  
  if (!isset($options['wall_post_flag']))
    $options['wall_post_flag'] = false;
  
  $captcha = get_post_meta($post->ID, '_evc_wall_post_captcha', true);
  if (isset($captcha) && !empty($captcha))
    $options['wall_post_flag'] = true;
?>
<div class="misc-pub-section">
<p><input type="checkbox" <?php checked($options['wall_post_flag'],true); ?> name="evc_wall_post" /> Опубликовать на стене ВКонтакте (EVC)</p>

<?php
  if (isset($captcha) && !empty($captcha)) {
?>
<p><span style = "color: #FF0000; border-bottom: 1px solid #FF0000;">Не опубликовано!</span>
<br/><img src = "<?php echo $captcha['img']; ?>" style = "margin:10px 0 3px;" />
<br/><input type="hidden" name="captcha_sid" value="<?php echo $captcha['sid']; ?>"><input type="text" value="" autocomplete="off" size="16" class="form-input-tip" name="captcha_key">
<br/>Введите текст с картинки, чтобы опубликовать запись ВКонтакте.</p>
<?php 
  }
?>
</div>
<?php
}

// this function prevents edits to existing posts from auto-posting
add_action('transition_post_status','evc_publish_auto_check',10,3);
function evc_publish_auto_check($new, $old, $post) {
  $options = get_option('evc_autopost'); 
  
  if (($new == 'publish' && $old != 'publish' && $options['autopublish']) || ($_POST['evc_wall_post'] && $new == 'publish') ) {  
    if (!isset($options['exclude_cats']) || empty($options['exclude_cats']) || !in_category($options['exclude_cats'], $post))
      evc_wall_post($post->ID, $post);
  }
}

function evc_wall_post ($id, $post) {

  //$options = get_option('evc_options');   
  $options = evc_get_all_options(array(
    'evc_vk_api_autopost',
    'evc_autopost'
  ));   
  
  // Post to wall 
  $m = array();
  preg_match_all('/%([\w-]*)%/m', $options['message'], $mt, PREG_PATTERN_ORDER);
 
  if (in_array('title', $mt[1])) {
    $m['%title%'] = get_the_title($post->ID);
    $m['%title%'] = strip_tags($m['%title%']);
    $m['%title%'] = html_entity_decode($m['%title%'], ENT_QUOTES, 'UTF-8');
    $m['%title%'] = htmlspecialchars_decode($m['%title%']);
  } 

  if (in_array('excerpt', $mt[1]))
    $m['%excerpt%'] = evc_make_excerpt($post); 
  
  if (in_array('link', $mt[1]))
    $m['%link%'] = apply_filters('evc_publish_permalink', null, $post->ID);    

  $message = str_replace( array_keys($m), array_values($m), $options['message'] );
  $message = strip_tags($message);
  $message = html_entity_decode($message, ENT_QUOTES, 'UTF-8');
  $message = htmlspecialchars_decode($message);  
 
  $permalink = $options['format']['add_link'] ? apply_filters('evc_publish_permalink', wp_get_shortlink($post->ID), $post->ID) : ''; 
  
  $attach = array();
  $images = evc_upload_photo($id, $post);  
  if ($images['i'])
    $attach[] = implode(',',$images['i']);
  if (!empty($permalink))
    $attach[] = $permalink;
  
  $params = array();
   
  $params = array(
    'access_token' => $options['access_token'],  
    'owner_id' => apply_filters('evc_wall_post_gid', '-' . $options['page_id'], $post),
    // 1: from group name; 0: from username
    'from_group' => isset($options['format']['from_group']) && !empty($options['format']['from_group']) ? 1 : 0, 
    // add username to post?
    'signed' => isset($options['format']['signed']) && !empty($options['format']['signed']) ? 1 : 0,
    'message' => $message,     
    // if no attachments - 'message' is available
    //'attachments' => $attachments 

  ); 
  
  // CAPTCHA
  if (isset($_POST['captcha_sid']) && isset($_POST['captcha_key']) && !empty($_POST['captcha_sid']) && !empty($_POST['captcha_key']) ) {
    $params['captcha_sid'] = $_POST['captcha_sid'];
    $params['captcha_key'] = trim($_POST['captcha_key']);
  }
  
  if (!empty($attach))
    $params['attachments'] = implode(',', $attach);
    
  $query = http_build_query($params);  
  
  $data = wp_remote_get(EVC_API_URL.'wall.post?'.$query, array('sslverify' => false)); 
  
  if (is_wp_error($data))
    return $data->get_error_message();
  
  $resp = json_decode($data['body'],true);  

  if ($resp['error']) {
    if ($resp['error']['error_code'] == 14) {
      $captcha = array(
        'sid' => $resp['error']['captcha_sid'],
        'img' => $resp['error']['captcha_img']
      );
      update_post_meta($post->ID, '_evc_wall_post_captcha', $captcha);
          
      if (!isset($options['error_email'])) {
        // Admin Notification
        $from = array('From:"'.get_option('blogname').'" <'.get_option('admin_email').'>');  

        $message  = 'Запись ВКонтакте не опубликована' . "\r\n\r\n";
        $message  .= 'Требуется captcha (пройдите по ссылке): ' . admin_url('post.php?post='.$post->ID.'&action=edit') . "\r\n\r\n";
        $message  .= 'ВНИМАНИЕ!'."\r\n".'Это уведомление отправляется только ОДИН раз.'."\r\n".'Пока не введена captcha дальнейшая публикация записей ВКонтакте НЕВОЗМОЖНА.';
        $message  .= "\r\n\r\n".'Ответы на ваши вопросы можно найти тут: .';
        $message  .= "\r\n\r\n".'Спасибо, что выбрали Easy VKontakte Connect (EVC), пожалуй один из лучших плагинов интеграции с ВКонтактом )';

        @wp_mail(get_option('admin_email'), 'EVC: требуется captcha!', $message, $from);

        $options['error_email'] = current_time('timestamp', 1);
      }
    }
  }
  else {
    delete_post_meta($post->ID, '_evc_wall_post_captcha');
    unset($options['error_email']);  
  }
  update_option('evc_autopost', $options);     

  // Wall Post with link  
  if ($resp['response']['processing'] || $resp['response']['post_id']) {
    update_post_meta($post->ID, '_evc_wall_post', date("Y-m-d H:i:s"));
    update_post_meta($post->ID, '_evc_wall_post_id', $resp['response']['post_id']);
  }

  return true;
}

function evc_upload_photo($id, $post) {
  
  //$options = get_option('evc_options');
  $options = evc_get_all_options(array(
    'evc_vk_api_autopost',
    'evc_autopost'
  ));  
  
  if (!$options['upload_photo_count'])
    return false;
  if ($options['upload_photo_count'] > 5)
    $options['upload_photo_count'] = 5;
    
  // Find first 5 attached images  
  $post_images = get_children( array( 
    'post_parent' => $post->ID, 
    'post_status' => 'inherit',     
    'post_type' => 'attachment', 
    'post_mime_type' => 'image', 
    'orderby' => 'menu_order id', 
    'order' => 'ASC', 
    'numberposts' => $options['upload_photo_count'] 
  ));  
  // if no attached photo
  if (!$post_images)
    return false;
  
  if ( $post_images ) {
    $i = 1;
    foreach($post_images as $image) {
      $images['file'.$i] = '@' . get_attached_file($image->ID );
      $i++;
    }
  }  
 
  $params = array(
    'access_token' => $options['access_token'],
    'gid' => $options['page_id'] // Removed minus sign
  );
  
  // Get Wall Upload Server
  $query = http_build_query($params);
  $data = wp_remote_get(EVC_API_URL.'photos.getWallUploadServer?'.$query, array('sslverify' => false));
    
  if (is_wp_error($data))
    return $data->get_error_message();

  $resp = json_decode($data['body'],true);
  if (!$resp['response']['upload_url'])
    return false;
    
  // Upload photo to server  
  $curl = new Wp_Http_Curl();
  $data = $curl->request( $resp['response']['upload_url'], array(
    'body' => $images, 
    'method' => 'POST'
  ));    
  
  if (is_wp_error($data))
    return $data->get_error_message();
  
  $resp = json_decode($data['body'],true);
  if (!$resp['photo'])
    return false;
  
  // Save Wall Photo
  $params = array();
  $params = array(
    'access_token' => $options['access_token'],
    'gid' => $options['page_id'], // Removed minus sign
    'server' => $resp['server'],
    'photo' => $resp['photo'],
    'hash' => $resp['hash']
  ); 
  $query = http_build_query($params);
  $data = wp_remote_get(EVC_API_URL.'photos.saveWallPhoto?'.$query, array('sslverify' => false));   
 
  if (is_wp_error($data))
    return $data->get_error_message();
  
  $resp = json_decode($data['body'],true);
  if (!$resp['response'])
    return false; 
  //print__r($resp);
  
  foreach($resp['response'] as $r)
    $attachments[] = $r['id'];
    
  return array('i' => $attachments);
}

// Main Idea from Otto, http://ottopress.com/wordpress-plugins/simple-facebook-connect/
function evc_make_excerpt($post) { 
  $options = get_option('evc_autopost');  
  
  if ( !empty($post->post_excerpt) ) 
    $text = $post->post_excerpt;
  else 
    $text = $post->post_content;
  
  $text = strip_shortcodes( $text );

  // filter the excerpt or content, but without texturizing
  if ( empty($post->post_excerpt) ) {
    remove_filter( 'the_content', 'wptexturize' );
    $text = apply_filters('the_content', $text);
    add_filter( 'the_content', 'wptexturize' );
  } else {
    remove_filter( 'the_excerpt', 'wptexturize' );
    $text = apply_filters('the_excerpt', $text);
    add_filter( 'the_excerpt', 'wptexturize' );
  }

  $text = str_replace(']]>', ']]&gt;', $text);
  $text = wp_strip_all_tags($text);
  $text = str_replace(array("\r\n","\r","\n"),"\n\n",$text);

  $excerpt_more = apply_filters('excerpt_more', '...');
  $excerpt_more = html_entity_decode($excerpt_more, ENT_QUOTES, 'UTF-8');
  $text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
  $text = htmlspecialchars_decode($text);
  
  //$max = min(500, apply_filters('evc_excerpt_length', 500));
  
  $max = !empty($options['excerpt_length']) ? $options['excerpt_length'] : 20;
  
  if ($max < 1) return ''; // nothing to send
  $words = explode(' ', $text);
  
  if (count($words) >= $max) {
    $words = array_slice($words, 0, $max);
    array_push ($words, $excerpt_more);
    $text = implode(' ', $words);
  }
  
  $text = evc_excerpt_strlen($text);
  
  return $text;
}


function evc_excerpt_strlen ($text, $max_strlen = 2688) {
  $options = get_option('evc_autopost');  
  
  if (isset($options['excerpt_length_strings']) && !empty($options['excerpt_length_strings'])) {
    $max_strlen = $options['excerpt_length_strings'] > $max_strlen ? $max_strlen : $options['excerpt_length_strings'];
  }
  
  if (strlen($text) >= $max_strlen) {
    $text = substr($text, 0, $max_strlen);
    $words = explode(' ', $text);
    array_pop($words); // strip last word
    
    $excerpt_more = apply_filters('excerpt_more', '...');
    $excerpt_more = html_entity_decode($excerpt_more, ENT_QUOTES, 'UTF-8');
    array_push ($words, $excerpt_more);
    
    $text = implode(' ', $words);
  }

  return $text;
}

/*
add_filter( 'evc_excerpt_length', 'theme_evc_excerpt_length' );
function theme_evc_excerpt_length() {
  return  20;
}
*/

// fix shortlink 
add_filter('evc_publish_permalink', 'evc_publish_shortlink_fix', 10, 2);
function evc_publish_shortlink_fix($link, $id) {
  if (empty($link)) 
    $link = get_permalink($id);
  
  return $link;
}



